# -*- coding: utf-8 -*-
from openerp.http import request as r

def get_stock_valuation_with_variant_cost_price():
    user_store = r.env.user.store_id.id
    query = '''
        SELECT
        	location.id,
        	quant.id,
        	quant.qty,
        	quant.product_id,
        	(array_agg(variant_cost_history.cost ORDER BY variant_cost_history.id DESC))[1] * quant.qty as variant_cost,
        	(array_agg(template_cost_history.cost ORDER BY template_cost_history.id DESC))[1] * quant.qty as template_cost
        FROM stock_location AS location
        LEFT JOIN stock_quant AS quant
        ON quant.location_id = location.id
        LEFT JOIN product_product AS product
        ON product.id = quant.product_id
        LEFT JOIN product_price_history_product AS variant_cost_history
        ON variant_cost_history.product_id = product.id
        LEFT JOIN product_price_history AS template_cost_history
        ON template_cost_history.product_template_id = product.product_tmpl_id
        WHERE location.usage = 'internal'
        AND location.active = TRUE
        --AND product.active = TRUE
        GROUP BY
        	location.id,
        	quant.id,
        	quant.qty,
        	quant.product_id
    '''

    r.cr.execute(query)

    data = [
        {
            'location_id': j[0],
            'quant_id': j[1],
            'qty': j[2],
            'product_id': j[3],
            'variant_cost': j[4],
            'template_cost': j[5],
        } for j in r.cr.fetchall()
    ]

    # values = []
    # valuation = 0
    # quantity = 0
    # value = 0;
    #
    # #
    # for item in data:
    #     value = item['cost']
    #     valuation += value
    #
    #     # quantity += item['qty']
    # print('*************************', valuation)
    #
    # # values.append({
    # #     'valuation': valuation,
    # #     'quantity': quantity,
    # # })
    return data
    # return values
