function ranking_sale_by_store(widget) {
    "use strict";

    var model = openerp;
    var Qweb = openerp.web.qweb;

    widget.RankingSaleByStore = widget.Base.extend({
        template: 'RankingSaleByStore',
        init: function (parent) {
            this._super(parent, {
                width: 6,
                height: 4
            });
        },
        start: function () {
            var self = this;
            self.fetchInitial();
        },
        fetchInitial: function(){
            var self = this;
            self.fetchDataSQL().then(function (DataSQL) {
                return DataSQL;
            }).then(function(DataSQL) {
                self.ResCompany = DataSQL.company;
                self.AccountInvoice = DataSQL.invoices;
                self.PosOrder = DataSQL.orders;
                self.ResStore = DataSQL.stores;
                return self.StoreRanking();
            });
        },
        fetchDataSQL: function() {
            var data = $.get('/dashboard-RankingSaleByStore');
            return data;
        },
        getPosOrder:function(id) {
            var self = this;
            return _.flatten(_.filter(self.PosOrder,function (inv) {
                return inv.store_id === id;
            }));
        },
        getAccountInvoice:function(id) {
            var self = this;
            return _.flatten(_.filter(self.AccountInvoice,function (inv) {
                return inv.store_id === id && inv.type == 'out_invoice' && inv.origin.match(/SO/) != null;
            }));
        },
        getAccountInvoiceRefund:function(id) {
            var self = this;
            return _.flatten(_.filter(self.AccountInvoice,function (inv) {
                return inv.store_id === id && inv.type == 'out_refund';
            }));
        },
        StoreRanking: function() {
            var self = this;
            var ranking = [];
            _.each(self.ResStore, function (item) {
                var PosOrder = self.getPosOrder(item.id);
                var AccountInvoice = self.getAccountInvoice(item.id);
                var AccountInvoiceRefund = self.getAccountInvoiceRefund(item.id);
                var pos_order_amount = _.reduce(_.map(PosOrder,function(item) {
                    var utc = moment.utc(item.date,'YYYY-MM-DD h:mm:ss A');
                    utc = moment(utc._d).format('YYYY-MM-DD');
                    var value = 0;
                    if(moment(utc).format('YYYY-MM') == moment().format('YYYY-MM')){
                        value = item.amount;
                    }
                    return value;
                }),function(memo, num) {
                    return memo + num;
                },0);
                var account_invoice_amount = _.reduce(_.map(AccountInvoice,function(item) {
                    return item.amount;
                }),function(memo, num) {
                    return memo + num;
                },0);
                var account_invoice_refund_amount = _.reduce(_.map(AccountInvoiceRefund,function(item) {
                    return item.amount;
                }),function(memo, num) {
                    return memo + num;
                },0);
                var amount = (pos_order_amount + account_invoice_amount) - account_invoice_refund_amount;
                if(amount > 0 ){
                    ranking.push({
                        name: item.name,
                        amount: amount,
                    });
                }
            });
            ranking.sort(function(a, b) {
                return b.amount - a.amount;
            });
            self.BuildChart(ranking);
        },
        BuildChart: function (ranking){
            var self = this;
            var label = [];
            var body = [];
            var item;
            var CurrencyBase = self.ResCompany[0].currency_id;
            for (var i = 0; i < ranking.length; i++) {
                item = ranking[i];
                label.push(item.name);
                body.push(item.amount);
            }
            var name = '.ranking-sale-by-store-chart';
            var chart = new widget.DashboardChartWidget(self);
            chart.BuildHorizontalBarChart(name,CurrencyBase,label,body);
        }
    });
}
