function dashboard_reporting_widget (instance, widget) {
    "use strict";

    var widgets = widget;
    var InstalledModule = 0;

    widget.DashboardReportingWidget = instance.Widget.extend({
        template: 'DashboardReportingTemplate',
        widgets: [],
        grid: {},

        start: function () {
            // instance.eiru_sidebar_toggler.sidebar_fold();
            this.$el.find('.grid-stack.reporting-dashboard').gridstack({
                animate: true,
                disableResize: true,
                disableDrag: true,
            });
            this.grid = this.$el.find('.grid-stack.reporting-dashboard').data('gridstack');
            this.fetchInitial();
        },

        fetchInitial: function(){
            var self = this;
            self.fetchDataSQL().then(function (DataSQL) {
                return DataSQL;
            }).then(function(DataSQL) {
                self.Widgets = DataSQL.widgets;
                return self.RenderWidgets();
            });
        },

        fetchDataSQL: function() {
            var self = this;
            var data = $.get('/dashboard-widgets');
            return data;
        },

        RenderWidgets: function () {
            var self = this;
            var ChartList = self.Widgets;

            /*
            ==========================================================
                VENTAS / COMPRAS / GASTOS
            ==========================================================
            */
            var chart =  _.flatten(_.filter(ChartList,function (inv) {
                return inv.name == 'WidgetSalePurchaseExpense';
            }));
            if(chart.length > 0){
                var WidgetSalePurchaseExpense = new widgets.WidgetSalePurchaseExpense(self);
                WidgetSalePurchaseExpense.renderElement();
                WidgetSalePurchaseExpense.start();
                self.grid.addWidget(WidgetSalePurchaseExpense.$el, 0, 0,WidgetSalePurchaseExpense.size.width,WidgetSalePurchaseExpense.size.height,true);
            }


            /*
            ==========================================================
                INGRESO / EGRESO
            ==========================================================
            */
            var chart =  _.flatten(_.filter(ChartList,function (inv) {
                return inv.name == 'WidgetIncomeOutcome';
            }));
            if(chart.length > 0){
                var WidgetIncomeOutcome = new widgets.WidgetIncomeOutcome(self);
                WidgetIncomeOutcome.renderElement();
                WidgetIncomeOutcome.start();
                self.grid.addWidget(WidgetIncomeOutcome.$el, 0, 0,WidgetIncomeOutcome.size.width,WidgetIncomeOutcome.size.height,true);
            }
            /*
            ==========================================================
                ANALISIS DE VENTAS
            ==========================================================
            */
            var chart =  _.flatten(_.filter(ChartList,function (inv) {
                return inv.name == 'WidgetFinancialState';
            }));
            if(chart.length > 0){

                var WidgetFinancialState = new widgets.WidgetFinancialState(self);
                WidgetFinancialState.renderElement();
                WidgetFinancialState.start();
                self.grid.addWidget(WidgetFinancialState.$el, 0, 0,WidgetFinancialState.size.width,WidgetFinancialState.size.height,true);
            };

            /*
            ==========================================================
                BALANCE
            ==========================================================
            */
            var chart =  _.flatten(_.filter(ChartList,function (inv) {
                return inv.name == 'WidgetBalance';
            }));
            if(chart.length > 0){
                var WidgetBalance = new widgets.WidgetBalance(self);
                WidgetBalance.renderElement();
                WidgetBalance.start();
                self.grid.addWidget(WidgetBalance.$el, 0, 0,WidgetBalance.size.width,WidgetBalance.size.height,true);
            }
            /*
            ==========================================================
                RANKING DE CLIENTES
            ==========================================================
            */
            var chart =  _.flatten(_.filter(ChartList,function (inv) {
                return inv.name == 'RankingCustomer';
            }));
            if(chart.length > 0){
                var RankingCustomer = new widgets.RankingCustomer(self);
                RankingCustomer.renderElement();
                RankingCustomer.start();
                self.grid.addWidget(RankingCustomer.$el, 0, 0,RankingCustomer.size.width,RankingCustomer.size.height,true);
            }
            /*
            ==========================================================
                RANKING DE VENDEDORES
            ==========================================================
            */
            var chart =  _.flatten(_.filter(ChartList,function (inv) {
                return inv.name == 'RankingSalesman';
            }));
            if(chart.length > 0){
                var RankingSalesman = new widgets.RankingSalesman(self);
                RankingSalesman.renderElement();
                RankingSalesman.start();
                self.grid.addWidget(RankingSalesman.$el, 0, 0,RankingSalesman.size.width,RankingSalesman.size.height,true);
            }
            /*
            ==========================================================
                VENTAS POR SURCURSAL
            ==========================================================
            */
            var chart =  _.flatten(_.filter(ChartList,function (inv) {
                return inv.name == 'RankingSaleByStore';
            }));
            if(chart.length > 0){
                var RankingSaleByStore = new widgets.RankingSaleByStore(self);
                RankingSaleByStore.renderElement();
                RankingSaleByStore.start();
                self.grid.addWidget(RankingSaleByStore.$el, 0, 0,RankingSaleByStore.size.width,RankingSaleByStore.size.height,true);
            };
            /*
            ==========================================================
                STOCK
            ==========================================================
            */
            var chart =  _.flatten(_.filter(ChartList,function (inv) {
                return inv.name == 'WidgetStockValuation';
            }));
            if(chart.length > 0){
                var WidgetStockValuation = new widgets.WidgetStockValuation(self);
                WidgetStockValuation.renderElement();
                WidgetStockValuation.start();
                self.grid.addWidget(WidgetStockValuation.$el, 0, 0,WidgetStockValuation.size.width,WidgetStockValuation.size.height,true);
            }
            /*
            ==========================================================
                STOCK WITH VARIANT COST PRICE
            ==========================================================
            */
            var chart =  _.flatten(_.filter(ChartList,function (inv) {
                return inv.name == 'WidgetStockValuationVariantCostPrice';
            }));
            if(chart.length > 0){
                var WidgetStockValuationWithVariantCostPrice = new widgets.WidgetStockValuationVariantCostPrice(self);
                WidgetStockValuationWithVariantCostPrice.renderElement();
                WidgetStockValuationWithVariantCostPrice.start();
                self.grid.addWidget(WidgetStockValuationWithVariantCostPrice.$el, 0, 0,WidgetStockValuationWithVariantCostPrice.size.width,WidgetStockValuationWithVariantCostPrice.size.height,true);
            }
            /*
            ==========================================================
                CUENTAS A COBRAR / A PAGAR
            ==========================================================
            */
            var chart =  _.flatten(_.filter(ChartList,function (inv) {
                return inv.name == 'WidgetAccount';
            }));
            if(chart.length > 0){
                var WidgetAccount = new widgets.WidgetAccount(self);
                WidgetAccount.renderElement();
                WidgetAccount.start();
                self.grid.addWidget(WidgetAccount.$el, 0, 0,WidgetAccount.size.width,WidgetAccount.size.height,true);
            };
            /*
            ==========================================================
                BANCO Y CAJA
            ==========================================================
            */
            var chart =  _.flatten(_.filter(ChartList,function (inv) {
                return inv.name == 'WidgetBankCash';
            }));
            if(chart.length > 0){
                var WidgetBankCash = new widgets.WidgetBankCash(self);
                WidgetBankCash.renderElement();
                WidgetBankCash.start();
                self.grid.addWidget(WidgetBankCash.$el, 0, 0,WidgetBankCash.size.width,WidgetBankCash.size.height,true);
            };
            /*
            ==========================================================
                RRHH
            ==========================================================
            */
            var chart =  _.flatten(_.filter(ChartList,function (inv) {
                return inv.name == 'WidgetRRHH';
            }));
            if(chart.length > 0){
                var WidgetRRHH = new widgets.WidgetRRHH(self);
                WidgetRRHH.renderElement();
                WidgetRRHH.start();
                self.grid.addWidget(WidgetRRHH.$el, 0, 0,WidgetRRHH.size.width,WidgetRRHH.size.height,true);
            };
        }
    });
}
