function widget_account(widget) {
    "use strict";

    var model = openerp;
    var Qweb = openerp.web.qweb;

    widget.WidgetAccount = widget.Base.extend({
        template: 'WidgetAccount',
        modelId: [],
        data: [],

        events: {
            'click .toReceibe': 'showModal',
            'click .toPay': 'showModal',
        },

        init: function (parent) {
            this._super(parent, {
                width: 6,
                height: 3
            });
        },

        start: function () {
            var self = this;
            self.fetchInitial();
        },

        fetchInitial: function(){
            var self = this;
            self.fetchDataSQL().then(function (DataSQL) {
                return DataSQL;
            }).then(function(DataSQL) {
                self.ResCompany = DataSQL.company;
                self.AccountMoveLine = DataSQL.move_lines;
                self.AccountVoucher = DataSQL.vouchers;
                self.AccountMoveLinePartialReconcile = DataSQL.reconcile_partials;
                return self.fetchCustomerModel();
            }).then(function(CustomerModel) {
                self.CustomerModel = CustomerModel;
                return self.fetchSupplierModel();
            }).then(function(SupplierModel) {
                self.SupplierModel = SupplierModel;
                return self.show();
            });
        },

        fetchDataSQL: function() {
            var self = this;
            var data = $.get('/dashboard-Account');
            return data;
        },

        fetchCustomerModel: function() {
            var self = this;
            var defer = $.Deferred();
            var irModelData = new model.web.Model('ir.model.data');
            var getObtjectReference = irModelData.get_func('get_object_reference');
            this.alive(getObtjectReference('account', 'invoice_form')).then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },

        fetchSupplierModel: function() {
            var self = this;
            var defer = $.Deferred();
            var irModelData = new model.web.Model('ir.model.data');
            var getObtjectReference = irModelData.get_func('get_object_reference');
            this.alive(getObtjectReference('account', 'invoice_supplier_form')).then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },

        getAccountMoveLinePartialReconcile: function (id) {
            var self = this;
            return _.filter(self.AccountMoveLinePartialReconcile,function (item) {
                return item.reconcile_partial_id == id;
            });
        },

        getAccountInvoice: function () {
            var self = this;
            var invoice_numbers = _.flatten(_.map(self.AccountMoveLine, function (item) {
                return item.number;
            }));
            return _.uniq(invoice_numbers);
        },

        getAccountMoveLine: function (number) {
            var self = this;
            var lines = _.filter(self.AccountMoveLine,function (item) {
                return item.number == number;
            });
            var x = lines.length;
            var i = 1;
            var content =_.map(lines, function(item){
                item.description = 'Cuota ' + i +' / ' + x;
                i++;
                return item;
            });
            return content;
        },

        getAccountVoucher: function (number) {
            var self = this;
            var valor = _.reduce(_.map(self.AccountVoucher, function (map) {
                if(map.reference == number){
                    return map.amount_currency;
                }else{
                    return 0;
                }
            }), function (memo, num) {
                return memo + num;
            });
            return valor;
        },

        getContent: function (type) {
            var self = this;
            var data = [];
            var CurrencyBase = self.ResCompany[0].currency_id;
            var AccountInvoice = self.getAccountInvoice();
            _.each(AccountInvoice,function(index) {
                var AccountMoveLine = self.getAccountMoveLine(index);
                _.each(AccountMoveLine,function(item) {
                    var residual = 0;
                    var reconcile = 0;
                    if(item.debit > 0 && item.date_maturity != false && type == 'toReceibe'){
                        residual = 0;
                        if(item.reconcile_id != null){
                            return;
                        }
                        if(item.reconcile_partial_id == null){
                            residual = item.debit;
                        }else{
                            reconcile = self.getAccountMoveLinePartialReconcile(item.reconcile_partial_id);
                            reconcile = _.reduce(_.map(reconcile, function (map) {
                                return map.credit;
                            }), function (memo, num) {
                                return memo + num;
                            },0);
                            residual = item.debit - reconcile;
                        }
                        data.push({
                            'invoice_id': item.invoice_id,
                            'month': moment(item.date_maturity).format('YYYY-MM'),
                            'date': item.date_maturity,
                            'ruc': item.ruc,
                            'partner': item.partner,
                            'number': item.number,
                            'description': item.description,
                            'date_maturity': moment(item.date_maturity).format('DD/MM/YYYY'),
                            'residual': accounting.formatMoney(residual, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                            'value': item.debit,
                        });
                    }else{
                        if(item.credit > 0 && item.date_maturity != false && type == 'toPay'){
                            residual = 0;
                            if(item.reconcile_id != null){
                                return;
                            }
                            if(item.reconcile_partial_id == null){
                                residual = item.credit;
                            }else{
                                reconcile = self.getAccountMoveLinePartialReconcile(item.reconcile_partial_id);
                                reconcile = _.reduce(_.map(reconcile, function (map) {
                                    return map.debit;
                                }), function (memo, num) {
                                    return memo + num;
                                },0);
                                residual = item.credit - reconcile;
                            }
                            data.push({
                                'invoice_id': item.invoice_id,
                                'month': moment(item.date_maturity).format('YYYY-MM'),
                                'date': item.date_maturity,
                                'ruc': item.ruc,
                                'partner': item.partner,
                                'number': item.number,
                                'description': item.description,
                                'date_maturity': moment(item.date_maturity).format('DD/MM/YYYY'),
                                'residual': accounting.formatMoney(residual, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                                'value': item.credit,
                            });
                        }
                    }
                });
            });
            data.sort(function (a, b) {
                var x = a.date;
                var y = b.date;
                if (x > y) {
                    return -1;
                }
                if (x < y) {
                    return 1;
                }
                return 0;
            });
            return data;
        },

        show: function () {
            var self = this;
            var toReceibe = 0;
            var toPay = 0;
            var CurrencyBase = self.ResCompany[0].currency_id;
            var AccountInvoice = self.getAccountInvoice();
            _.each(AccountInvoice,function(index) {
                var AccountMoveLine = self.getAccountMoveLine(index);
                _.each(AccountMoveLine,function(item) {
                    var residual = 0;
                    var reconcile = 0;
                    if(item.debit > 0 && item.date_maturity != false){
                        residual = 0;
                        if(item.reconcile_id != null){
                            return;
                        }
                        if(item.reconcile_partial_id == null){
                            residual = item.debit;
                        }else{
                            /*
                                Si es una factura de cliente, el monto de la conciliacion
                                parcial esta guardado en credito
                            */
                            reconcile = self.getAccountMoveLinePartialReconcile(item.reconcile_partial_id);
                            reconcile = _.reduce(_.map(reconcile, function (map) {
                                return map.credit;
                            }), function (memo, num) {
                                return memo + num;
                            },0);
                            residual = item.debit - reconcile;
                        }
                        toReceibe += residual;
                    }
                    if(item.credit > 0 && item.date_maturity != false){
                        residual = 0;
                        if(item.reconcile_id != null){
                            return;
                        }
                        if(item.reconcile_partial_id == null){
                            residual = item.credit;
                        }else{
                            /*
                                Si es una factura de proveedor, el monto de la conciliacion
                                parcial esta guardado en debito
                            */
                            reconcile = self.getAccountMoveLinePartialReconcile(item.reconcile_partial_id);
                            reconcile = _.reduce(_.map(reconcile, function (map) {
                                return map.debit;
                            }), function (memo, num) {
                                return memo + num;
                            },0);
                            residual = item.credit - reconcile;
                        }
                        toPay += residual;
                    }
                });
            });
            self.$el.find('.widget-content').find('#acobrar').text(accounting.formatMoney(toReceibe, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator));
            self.$el.find('.widget-content').find('#apagar').text(accounting.formatMoney(toPay, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator));
        },

        RedirectToReceibe: function() {
            var self = this;
            self.do_action({
                type: 'ir.actions.client',
                tag: "eiru_reports.dues_analysis_action",
                target: 'current',
                params: {},
                context: self.session.user_context,
            });
            self.removeModal();
        },

        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = $('.account-table');
            table.bootstrapTable('load', rowsTable);
        },

        showModal: function (e){
            var self = this;
            var titleData = [];
            var CurrencyBase = self.ResCompany[0].currency_id;
            var type = $(e.target).closest('a')[0].className;
            
            var data = self.getContent(type);
            if(type == 'toReceibe'){
                titleData.push({
                    'title': 'Cuentas a cobrar'
                });
            }else{
                titleData.push({
                    'title': 'Cuentas a pagar'
                });
            }
            var modal = Qweb.render('WidgetAccountModal', {
                modalTitle: titleData,
            });
            $('.openerp_webclient_container').after(modal);
            $('.dashboard-account-modal').modal();
            $('.dashboard-account-modal').on('hidden.bs.modal', function (e) {
                self.removeModal(e);
            });
            var contenido = $('.dashboard-account-modal').find('.redirect-to-report');
            contenido.click(function (e) {
                if(type == 'toReceibe'){
                    self.RedirectToReceibe();
                }
            });
            var table = $('.dashboard-account-modal').find('.account-table');
            table.click(function (e) {
                $(table).find('tr').removeClass('table-row-select');
                $(e.target).closest('tr').addClass('table-row-select');
                var id = $(e.target).closest('tr').children()[0].textContent;
                if(type == 'toReceibe'){
                    self.RenderCustomerForm(id);
                }else{
                    self.RenderSupplierForm(id);
                }
            });
            self.loadTable(data);
        },

        removeModal: function (e) {
            $('.dashboard-account-modal').remove();
            $('.modal-backdrop').remove();
        },

        RenderCustomerForm: function(id){
            var self = this;
            id = parseInt(id);
            this.do_action({
                type: "ir.actions.act_window",
                res_model: "account.invoice",
                views: [[self.CustomerModel[1], 'form']],
                target: 'current',
                domain: [['id', '=', id]],
                context: {},
                res_id: id,
            }).then(function() {
                self.removeModal();
            });
        },

        RenderSupplierForm: function(id){
            var self = this;
            id = parseInt(id);
            this.do_action({
                type: "ir.actions.act_window",
                res_model: "account.invoice",
                views: [[self.SupplierModel[1], 'form']],
                target: 'current',
                domain: [['id', '=', id]],
                context: {},
                res_id: id,
            }).then(function() {
                self.removeModal();
            });
        }
    });
}
