function widget_bank_cash(widget) {
    "use strict";

    var model = openerp;
    var Qweb = openerp.web.qweb;

    widget.WidgetBankCash = widget.Base.extend({
        template: 'WidgetBankCash',
        ModelBank: [],
        ModelCash: [],
        DataBank: [],
        DataCash: [],
        events: {
            'click .bank': 'showModal',
            'click .cash': 'showModal',
        },
        init: function (parent) {
            this._super(parent, {
                width: 6,
                height: 3
            });
        },
        start: function () {
            var self = this;
            self.fetchInitial();
        },
        fetchInitial: function(){
            var self = this;
            self.fetchDataSQL().then(function (DataSQL) {
                return DataSQL;
            }).then(function(DataSQL) {
                self.ResCompany = DataSQL.company;
                self.AccountBankStatement = DataSQL.statements;
                return self.fetchGetModelBank();
            }).then(function(ModelBank) {
                self.ModelBank= ModelBank;
                return self.fetchGetModelCash();
            }).then(function(ModelCash) {
                self.ModelCash= ModelCash;
                return self.show();
            });
        },
        fetchDataSQL: function() {
            var self = this;
            var data = $.get('/dashboard-BankCash');
            return data;
        },
        fetchGetModelBank: function() {
            var self = this;
            var defer = $.Deferred();
            var irModelData = new model.web.Model('ir.model.data');
            var getObtjectReference = irModelData.get_func('get_object_reference');
            this.alive(getObtjectReference('account', 'view_bank_statement_form')).then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },
        fetchGetModelCash: function() {
            var self = this;
            var defer = $.Deferred();
            var irModelData = new model.web.Model('ir.model.data');
            var getObtjectReference = irModelData.get_func('get_object_reference');
            this.alive(getObtjectReference('account', 'view_bank_statement_form2')).then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },
        show: function () {
            var self = this;
            var bank = 0;
            var cash = 0;
            var DataCash = [];
            var DataBank = [];
            var AccountBankStatement = self.AccountBankStatement;
            var CurrencyBase = self.ResCompany[0].currency_id;
            if(AccountBankStatement.length > 0){
                bank = _.reduce(_.map(AccountBankStatement, function (map) {
                    if(map.journal_type == 'bank'){
                        if(map.journal_currency != null){
                            var balance_end = accounting.formatMoney(map.balance_end, map.symbol, map.decimal_places, map.thousands_separator, map.decimal_separator);
                        }else{
                            var balance_end = accounting.formatMoney(map.balance_end, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator)
                        }
                        DataBank.push({
                            'id':map.id,
                            'name':map.name,
                            'journal_name':map.journal_name,
                            'balance_end':balance_end,
                            'balance_end_currency':accounting.formatMoney(map.balance_end_currency, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator)
                        });
                        return map.balance_end_currency;
                    }else{
                        return 0;
                    }
                }), function (memo, num) {
                    return memo + num;
                });

                cash = _.reduce(_.map(AccountBankStatement, function (map) {
                    if(map.journal_type == 'cash'){
                        if(map.journal_currency != null){
                            var balance_end = accounting.formatMoney(map.balance_end, map.symbol, map.decimal_places, map.thousands_separator, map.decimal_separator);
                        }else{
                            var balance_end = accounting.formatMoney(map.balance_end, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator)
                        }
                        DataCash.push({
                            'id':map.id,
                            'name':map.name,
                            'journal_name':map.journal_name,
                            'balance_end':balance_end,
                            'balance_end_currency':accounting.formatMoney(map.balance_end_currency, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator)
                        });
                        return map.balance_end_currency;
                    }else{
                        return 0;
                    }
                }), function (memo, num) {
                    return memo + num;
                });
            };
            self.DataBank = DataBank;
            self.DataCash = DataCash;
            self.$el.find('.widget-content').find('#bank').text(accounting.formatMoney(bank, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator))
            self.$el.find('.widget-content').find('#cash').text(accounting.formatMoney(cash, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator))
        },
        showModal: function (e){
            var self = this;
            var titleData = [];
            var data = []
            var CurrencyBase = self.ResCompany[0].currency_id;
            var type = $(e.target).closest('a')[0].className;
            if(type == 'bank'){
                if (self.DataBank <= 0) {
                    model.web.notification.do_warn("Atención","Sin datos");
                    return
                }
                data = self.DataBank;
                titleData.push({
                    title: 'Extratos Bancarios Abiertos',
                });
            };
            if(type == 'cash'){
                if (self.DataCash <= 0) {
                    model.web.notification.do_warn("Atención","Sin datos");
                    return
                }
                data = self.DataCash;
                titleData.push({
                    title: 'Registros de caja abiertos',
                });
            };
            var modal = Qweb.render('BankCashModal', {
                modalTitle: titleData,
                data: data,
            });
            $('.openerp_webclient_container').after(modal);
            $('.dashboard-bank-cash-modal').modal();
            $('.dashboard-bank-cash-modal').on('hidden.bs.modal', function (e) {
                self.removeModal(e);
            });
            var contenido = $('.dashboard-bank-cash-modal').find('.statement-name');
            contenido.click(function (e) {
                var name = $(e.target).closest('.statement-name')[0].text;
                var statement =  _.flatten(_.filter(self.AccountBankStatement,function (inv) {
                    return inv.name == name;
                }));
                if(statement[0].journal_type == 'bank'){
                    self.renderBankForm(statement[0].id);
                }else{
                    self.renderCashForm(statement[0].id);
                };
           });
        },
        removeModal: function (e) {
            $('.dashboard-bank-cash-modal').remove();
            $('.modal-backdrop').remove();
        },
        renderBankForm: function(id){
            var self = this;
            id = parseInt(id);
            this.do_action({
                type: "ir.actions.act_window",
                res_model: "account.bank.statement",
                views: [[self.ModelBank[1], 'form']],
                target: 'current',
                domain: [['id', '=', id]],
                context: {},
                res_id: id,
            }).then(function() {
                self.removeModal();
            });
        },
        renderCashForm: function(id){
            var self = this;
            id = parseInt(id);
            this.do_action({
                type: "ir.actions.act_window",
                res_model: "account.bank.statement",
                views: [[self.ModelCash[1], 'form']],
                target: 'current',
                domain: [['id', '=', id]],
                context: {},
                res_id: id,
            }).then(function() {
                self.removeModal();
            });
        },
    });
}
