function widget_financial_state(widget) {
    "use strict";

    var model = openerp;

    widget.WidgetFinancialState = widget.Base.extend({
        template: 'WidgetFinancialState',
        content: [],

        events: {

        },

        init: function (parent) {
            this._super(parent, {
                width: 12,
                height: 5
            });
        },

        start: function () {
            var self = this;
            self.fetchInitial();
        },

        fetchInitial: function(){
            var self = this;
            self.fetchDataSQL().then(function (DataSQL) {
                return DataSQL;
            }).then(function(DataSQL) {
                self.ResCompany = DataSQL.company;
                self.AccountInvoiceLine = DataSQL.invoice_lines;
                self.PosOrderLine = DataSQL.order_lines;
                self.HrPayslip = DataSQL.payslips;
                return self.Show();
            });
        },

        fetchDataSQL: function() {
            var self = this;
            var data = $.get('/dashboard-FinancialState');
            return data;
        },

        Show: function () {
            var self = this;
            var label = ['Total','Sub-Total','Impuestos','Coste','Utilidad'];
            var body = [];
            var name = '.financial-chart';
            var sale = [];
            var expense = [];
            var CurrencyBase = self.ResCompany[0].currency_id;

            /*
            ==================================
                SALE
            ==================================
            */

            var SaleSubtotal = _.reduce(_.map(self.AccountInvoiceLine,function(item) {
                if(item.type == "out_invoice" && item.origin.match(/SO/) != null){
                    return item.subtotal;
                }else{
                    return 0;
                }
            }),function(memo, num) {
                return memo + num;
            },0);
            var SaleTax = _.reduce(_.map(self.AccountInvoiceLine,function(item) {
                if(item.type == "out_invoice" && item.origin.match(/SO/) != null){
                    return item.tax;
                }else{
                    return 0;
                }
            }),function(memo, num) {
                return memo + num;
            },0);
            var SaleCost = _.reduce(_.map(self.AccountInvoiceLine,function(item) {
                if(item.type == "out_invoice" && item.origin.match(/SO/) != null){
                    return item.cost * item.quantity;
                }else{
                    return 0;
                }
            }),function(memo, num) {
                return memo + num;
            },0);

            /*
            ==================================
                REFUND
            ==================================
            */

            var SaleRefundSubtotal = _.reduce(_.map(self.AccountInvoiceLine,function(item) {
                if(item.type == "out_refund"){
                    return item.subtotal;
                }else{
                    return 0;
                }
            }),function(memo, num) {
                return memo + num;
            },0);
            var SaleRefundTax = _.reduce(_.map(self.AccountInvoiceLine,function(item) {
                if(item.type == "out_refund"){
                    return item.tax;
                }else{
                    return 0;
                }
            }),function(memo, num) {
                return memo + num;
            },0);
            var SaleRefundCost = _.reduce(_.map(self.AccountInvoiceLine,function(item) {
                if(item.type == "out_refund"){
                    return item.cost * item.quantity;
                }else{
                    return 0;
                }
            }),function(memo, num) {
                return memo + num;
            },0);

            /*
            ==================================
                ORDER
            ==================================
            */

            var OrderSubtotal = _.reduce(_.map(self.PosOrderLine,function(item) {
                var utc = moment.utc(item.date,'YYYY-MM-DD h:mm:ss A');
                utc = moment(utc._d).format('YYYY-MM-DD');
                var value = 0;
                if(moment(utc).format('YYYY-MM') == moment().format('YYYY-MM')){
                    value = item.subtotal;
                }
                return value;
            }),function(memo, num) {
                return memo + num;
            },0);

            var OrderTax = _.reduce(_.map(self.PosOrderLine,function(item) {
                var utc = moment.utc(item.date,'YYYY-MM-DD h:mm:ss A');
                utc = moment(utc._d).format('YYYY-MM-DD');
                var value = 0;
                if(moment(utc).format('YYYY-MM') == moment().format('YYYY-MM')){
                    value = item.tax;
                }
                return value;
            }),function(memo, num) {
                return memo + num;
            },0);

            var OrderCost = _.reduce(_.map(self.PosOrderLine,function(item) {
                var utc = moment.utc(item.date,'YYYY-MM-DD h:mm:ss A');
                utc = moment(utc._d).format('YYYY-MM-DD');
                var value = 0;
                if(moment(utc).format('YYYY-MM') == moment().format('YYYY-MM')){
                    value = item.cost * item.quantity;
                }
                return value;
            }),function(memo, num) {
                return memo + num;
            },0);

            var subtotal = SaleSubtotal + OrderSubtotal - SaleRefundSubtotal;
            var tax = SaleTax + OrderTax - SaleRefundTax;
            var cost = SaleCost + OrderCost - SaleRefundCost;
            var ganancia = subtotal - cost;
            var Rentabilidad = (ganancia / cost) * 100;
            var utilidad = (ganancia / subtotal) * 100;

            body.push(Math.round(subtotal + tax));
            body.push(subtotal);
            body.push(tax);
            body.push(cost);
            body.push(ganancia);

            sale.push({
                subtotal: accounting.formatMoney(subtotal, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                tax: accounting.formatMoney(tax, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                cost: accounting.formatMoney(cost, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                margin : accounting.formatNumber(utilidad,2,".",",") + '%',
                total: accounting.formatMoney(subtotal + tax, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                utility: accounting.formatMoney(ganancia, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                profitability: accounting.formatNumber(Rentabilidad,2,".",",") + '%',
            });

            // GASTOS
            var ExpenseSubtotal = _.reduce(_.map(self.AccountInvoiceLine,function(item) {
                if(item.type == "in_invoice"){
                    if(item.origin == null){
                        return item.subtotal;
                    }else{
                        var subtotal = 0;
                        if(item.origin != null){
                            if(item.origin.match(/PO/) == null){
                                subtotal = item.subtotal;
                            }
                        }
                        return subtotal;
                    }
                }else{
                    return 0;
                }
            }),function(memo, num) {
                return memo + num;
            },0);

            var ExpenseTax = _.reduce(_.map(self.AccountInvoiceLine,function(item) {
                if(item.type == "in_invoice"){
                    if(item.origin == null){
                        return item.tax;
                    }else{
                        var tax = 0;
                        if(item.origin != null){
                            if(item.origin.match(/PO/) == null){
                                subtotal = item.tax;
                            }
                        }
                        return tax;
                    }
                }else{
                    return 0;
                }
            }),function(memo, num) {
                return memo + num;
            },0);

            //RRHH

            var net = _.reduce(_.map(self.HrPayslip,function(item) {
                return item.net;
            }),function(memo, num) {
                return memo + num;
            },0);

            var ipsc = _.reduce(_.map(self.HrPayslip,function(item) {
                if(item.code == 'IPSC' && item.ipsc != null){
                    return item.ipsc;
                }else{
                    return 0;
                }
            }),function(memo, num) {
                return memo + num;
            },0);

            var ipse = _.reduce(_.map(self.HrPayslip,function(item) {
                if(item.code == 'IPSE' && item.ipse != null){
                    return item.ipse * -1;
                }else{
                    return 0;
                }
            }),function(memo, num) {
                return memo + num;
            },0);

            ExpenseSubtotal = ExpenseSubtotal + net + ipse + ipsc;

            expense.push({
                subtotal: accounting.formatMoney(ExpenseSubtotal, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                tax: accounting.formatMoney(ExpenseTax, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                total: accounting.formatMoney(ExpenseSubtotal + ExpenseTax, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
            });

            self.$el.find('.widget-content').find('.company').text(self.ResCompany[0].name);
            self.$el.find('.widget-content').find('.store').text(self.ResCompany[0].store);
            self.$el.find('.widget-content').find('.ruc').text(self.ResCompany[0].ruc);
            self.$el.find('.widget-content').find('.balance-end').text(accounting.formatMoney(ganancia - ExpenseSubtotal, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator));
            self.loadTable(sale);
            self.loadExpenseTable(expense);
            var chart = new widget.DashboardChartWidget(self);
            chart.BuildBarChart(name,CurrencyBase,label,body);
        },

        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('.financial-state-sale-table');
            table.bootstrapTable('load', rowsTable);
        },

        loadExpenseTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('.financial-state-expense-table');
            table.bootstrapTable('load', rowsTable);
        },
    });
}
