function widget_income_outcome(widget) {
    "use strict";

    var model = openerp;
    var Qweb = openerp.web.qweb;

    widget.WidgetIncomeOutcome = widget.Base.extend({
        template: 'WidgetIncomeOutcome',
        rowsData :[],
        content: [],
        label: [],
        body: [],
        Income: '',
        Outcome: '',
        modules: ['point_of_sale'],
        events: {
            'click .number_income': 'showModal',
            'click .number_outcome': 'showModal',
        },
        init: function (parent) {
            this._super(parent, {
                width: 6,
                height: 3
            });
        },
        start: function () {
            var self = this;
            self.fetchInitial();
        },
        checkModel : function(model){
            var self = this;
            return _.filter(self.IrModuleModule,function(item){
                return item.name === model;
            });
        },
        fetchInitial: function(){
            var self = this;
            self.fetchDataSQL().then(function (DataSQL) {
                return DataSQL;
            }).then(function(DataSQL) {
                self.ResCompany = DataSQL.company;
                self.AccountJournal = DataSQL.journals;
                self.AccountVoucher = DataSQL.vouchers;
                self.AccountBankStatementLine = DataSQL.statement_lines;
                return self.showThisMonth();
            });
        },
        fetchDataSQL: function() {
            var self = this;
            var data = $.get('/dashboard-IncomeOutcome');
            return data;
        },
        getAccountVoucher: function (id, type) {
            var self = this;
            return _.filter(self.AccountVoucher,function (item) {
                return item.journal_id === id && item.type == type;
            });
        },
        getAccountAccountBankStatementLine: function (id) {
            var self = this;
            return _.filter(self.AccountBankStatementLine,function (item) {
                return item.journal_id === id;
            });
        },
        showThisMonth: function () {
            var self = this;
            var AccountVoucher = _.reduce(_.map(self.AccountVoucher,function(item) {
                if(item.type == 'receipt'){
                    return item.amount_currency;
                }else{
                    return 0;
                }
            }),function(memo, num) {
                return memo + num;
            },0);
            var AccountBankStatementLine = _.reduce(_.map(self.AccountBankStatementLine,function(item) {
                return item.amount;
            }),function(memo, num) {
                return memo + num;
            },0);
            var AccountVoucherOut = _.reduce(_.map(self.AccountVoucher,function(item) {
                if(item.type == 'payment'){
                    return item.amount_currency;
                }else{
                    return 0;
                }
            }),function(memo, num) {
                return memo + num;
            },0);
            var amount = AccountVoucher + AccountBankStatementLine;
            var CurrencyBase = self.ResCompany[0].currency_id;
            self.$el.find('.widget-content').find('#number_income').text(accounting.formatMoney(amount, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator));
            self.$el.find('.widget-content').find('#number_outcome').text(accounting.formatMoney(AccountVoucherOut, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator));
            self.Income =accounting.formatMoney(amount, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
            self.Outcome = accounting.formatMoney(AccountVoucherOut, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
        },
        RedirectIncome: function() {
            var self = this;
            self.do_action({
                type: 'ir.actions.client',
                tag: "eiru_reports.income_summary_action",
                target: 'current',
                params: {},
                context: self.session.user_context,
            });
            self.removeModal();
        },
        RedirectOutcome: function() {
            var self = this;
            self.do_action({
                type: 'ir.actions.client',
                tag: "eiru_reports.outcome_summary_action",
                target: 'current',
                params: {},
                context: self.session.user_context,
            });
            self.removeModal();
        },
        ShowByPaymentType: function (type){
            var self = this;
            var data = [];
            var label = [];
            var body = [];
            var amount = 0;
            var amount_currency = 0;
            var voucher = 0;
            var voucher_currency = 0;
            var line = 0;
            var line_currency = 0;
            var CurrencyBase = self.ResCompany[0].currency_id;
            _.each(self.AccountJournal,function(item) {
                var AccountVoucher = self.getAccountVoucher(item.id, type);
                var AccountBankStatementLine = 0;
                if(type == 'receipt'){
                    AccountBankStatementLine = self.getAccountAccountBankStatementLine(item.id);
                }

                voucher = 0;
                voucher_currency = 0;
                _.each(AccountVoucher,function(index) {
                    if(index.currency_id != null){
                        voucher += index.amount;
                    }
                    voucher_currency += index.amount_currency;
                });

                line = 0;
                line_currency = 0;
                _.each(AccountBankStatementLine,function(index) {
                    if(index.currency_id != null){
                        line += index.amount;
                    }
                    line_currency += index.amount_currency;
                });

                amount_currency = voucher_currency + line_currency;
                amount = voucher + line;

                var value;
                if(item.currency == null){
                    value = accounting.formatMoney(amount_currency,CurrencyBase.symbol,CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
                }else{
                    value = accounting.formatMoney(amount_currency,CurrencyBase.symbol,CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator) + ' ( ' + accounting.formatMoney(amount,item.symbol,item.decimal_places, item.thousands_separator, item.decimal_separator) + ' )';
                }

                if(amount_currency > 0){
                    data.push({
                        'name':item.name,
                        'amount': amount_currency,
                        'value_amount': value,
                    });
                    label.push(item.name);
                    body.push(amount_currency);
                }
            });
            data.sort(function(a, b) {
                return b.amount - a.amount;
            });
            self.content = data;
            self.label = label;
            self.body = body;
        },

        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = $('.Income-Outcome-table');
            table.bootstrapTable('load', rowsTable);
        },
        BuildChart: function(label,body,CurrencyBase){
            var self = this;
            var name = '.dashboard-income-outcome-chart';
            var chart = new widget.DashboardChartWidget(self);
            chart.BuildDoughnutChart(name,label,body,CurrencyBase);
        },
        showModal: function (e){
            var self = this;
            var titleData = [];
            var CurrencyBase = self.ResCompany[0].currency_id;
            var type = $(e.target).closest('a')[0].className;
            var amount = '';
            if(type == 'number_income'){
                type = 'receipt';
                amount = self.Income;
                titleData.push({
                    'title': 'Resumen de Ingresos'
                });
            }else{
                type = 'payment';
                amount = self.Outcome;
                titleData.push({
                    'title': 'Resumen de Egresos'
                });
            }
            self.ShowByPaymentType(type);
            var modal = Qweb.render('DashboardIncomeOutcomeModal', {
                modalTitle: titleData,
                amount: amount
            });
            $('.openerp_webclient_container').after(modal);
            $('.dashboard-income-outcome-modal').modal();
            $('.dashboard-income-outcome-modal').on('hidden.bs.modal', function (e) {
                self.removeModal(e);
            });
            var contenido = $('.dashboard-income-outcome-modal').find('.redirect-to-report');
            contenido.click(function (e) {
                if(type == 'receipt'){
                    self.RedirectIncome();
                }else{
                    self.RedirectOutcome();
                }
            });
            self.loadTable(self.content);
            self.BuildChart(self.label,self.body,CurrencyBase);
        },
        removeModal: function (e) {
            $('.dashboard-income-outcome-modal').remove();
            $('.modal-backdrop').remove();
        },
    });
}
