function widget_rrhh(widget) {
    "use strict";

    var model = openerp;
    var Qweb = openerp.web.qweb;

    widget.WidgetRRHH = widget.Base.extend({
        template: 'WidgetRRHH',
        content: [],
        modules: ['eiru_reports_rrhh'],
        month: 0,
        week: 0,
        today: 0,
        objective: 0,
        percentage: 0,

        events: {
            'click .number': 'showModal',
        },

        init: function (parent) {
            this._super(parent, {
                width: 12,
                height: 6
            });
        },

        start: function () {
            var self = this;
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            self.fetchInitial();
        },

        checkModel : function(model){
            var self = this;
            return _.filter(self.IrModuleModule,function(item){
                return item.name === model;
            });
        },

        valorNull:function(dato){
            var valor = "";
            if (dato){
                valor = dato;
            }
            return valor;
        },

        fetchInitial: function(){
            var self = this;
            self.fetchDataSQL().then(function (DataSQL) {
                return DataSQL;
            }).then(function(DataSQL) {
                self.ResCompany = DataSQL.company;
                self.IrModuleModule = DataSQL.modules;
                return self.fetchHrPayslipTotal();
            }).then(function(HrPayslipTotal) {
                self.HrPayslipTotal = HrPayslipTotal;
                return self.fetchHHRR();
            }).then(function(HHRR) {
                self.HHRR = HHRR;
                return self.showThisMonth();
            });
        },

        fetchDataSQL: function() {
            var self = this;
            var data = $.get('/dashboard-rrhh');
            return data;
        },

        /*
        =====================================================
            HR PAYSLIP TOTAL
        =====================================================
        */
        fetchHrPayslipTotal: function(){
            var self = this;
            var date = moment().format('YYYY-MM');
            var modules = self.checkModel('eiru_reports_rrhh');
            if (modules.length > 0){
                var domain = [
                    ['date_to','like',date],
                    ['state','in',['done','paid']],
                ];
                var HrPayslipTotal = new model.web.Model('hr.employee');
                return HrPayslipTotal.call('getPayslipTotalWidget',[domain], {
                    context: new model.web.CompoundContext()
                });
            }else{
                return [];
            }
        },
        /*
        =====================================================
            HH RR
        =====================================================
        */
        fetchHHRR: function(){
            var self = this;
            var modules = self.checkModel('eiru_reports_rrhh');
            if (modules.length > 0){
                var domain = [
                    ['active', '=', true],
                    ['address_home_id', '!=', false],
                ];
                var HHRR = new model.web.Model('hr.employee');
                return HHRR.call('getHHRRWidget',[domain], {
                    context: new model.web.CompoundContext()
                });
            }else{
                return [];
            }
        },
        showThisMonth: function () {
            var self = this;

            var data = [];
            var label = [];
            var body = [];
            var CurrencyBase = self.ResCompany[0].currency_id;
            _.each(self.HHRR, function(item){
                if(item.payslip > 0){
                    label.push(item.name);
                    body.push(item.payslip);
                }
                data.push({
                    'identification_id': self.valorNull(item.identification_id),
                    'name': item.name,
                    'payslip': accounting.formatMoney(item.payslip, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    'amortized': accounting.formatMoney(item.amortized, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    'residual': accounting.formatMoney(item.residual, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                });
            });
            if(self.HrPayslipTotal.length > 0){
                self.$el.find('.widget-content').find('.pending').text(accounting.formatMoney(self.HrPayslipTotal[0].residual, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator));
                self.$el.find('.widget-content').find('.amortizado').text(accounting.formatMoney(self.HrPayslipTotal[0].amortized, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator));
                self.$el.find('.widget-content').find('.ips').text(accounting.formatMoney(self.HrPayslipTotal[0].ipse + self.HrPayslipTotal[0].ipsc, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator));
                self.$el.find('.widget-content').find('.total').text(accounting.formatMoney(self.HrPayslipTotal[0].payslip, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator));
            }
            self.loadTable(data);
            self.BuildChart(label,body,CurrencyBase);
        },
        BuildChart: function(label,body,CurrencyBase){
            var self = this;
            var name = '.doughnut-dashboard-chart';
            var chart = new widget.DashboardChartWidget(self);
            chart.BuildDoughnutChart(name,label,body,CurrencyBase);
        },
        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load', rowsTable);
        },
    });
}
