function widget_sale_purchase_expense(widget) {
    "use strict";

    var model = openerp;
    var Qweb = openerp.web.qweb;

    widget.WidgetSalePurchaseExpense = widget.Base.extend({
        template: 'WidgetSalePurchaseExpense',
        modules: ['point_of_sale'],
        /*
        ========================
            OBJETIVOS
        ========================
        */
        SaleObjetiveAmount: 0,
        PurchaseLimitAmount: 0,
        ExpenseLimitAmount: 0,
        PaymentObjetiveAmount:0,
        /*
        ========================
            MES
        ========================
        */
        SaleMonth: 0,
        PurchaseMonth: 0,
        ExpenseMonth: 0,
        PaymentMonth:0,
        /*
        ========================
            PORCENTAJES
        ========================
        */
        SalePercentage: 0,
        PurchasePercentage: 0,
        ExpensePercentage: 0,
        PaymentPercentage:0,
        content: [],

        events: {
            'click .number_sale': 'showModal',
            'click .number_purchase': 'showModal',
            'click .number_expense': 'showModal',
            'click .number_payment': 'showModal',
        },

        init: function (parent) {
            this._super(parent, {
                width: 6,
                height: 3
            });
        },

        fetchUTC: function(){
            var self = this;
            var date = moment().format('YYYY-MM-01 00:00:00');
            var utc = moment.utc(date,'YYYY-MM-DD h:mm:ss A');
            var first = moment('00:00:00','HH:mm:ss');
            var second = moment(moment(utc._d,'HH:mm:ss'));
            var data = moment.duration(first - second);
            return data._data.hours;
       },

        start: function () {
            var self = this;
            self.fetchInitial();
        },

        checkModel : function(model){
            var self = this;
            return _.filter(self.IrModuleModule,function(item){
                return item.name === model;
            });
        },

        fetchInitial: function(){
            var self = this;
            self.fetchDataSQL().then(function (DataSQL) {
                return DataSQL;
            }).then(function(DataSQL) {
                self.IrModuleModule = DataSQL.modules;
                self.ResCompany = DataSQL.company;
                self.DashboardObjetive = DataSQL.objetives;
                self.PosOrder = DataSQL.orders;
                self.AccountInvoice = DataSQL.invoices;
                self.HrPayslip = DataSQL.payslips;
                self.AccountVoucher = DataSQL.voucher;
                return self.fetchMonth();
            });
        },

        fetchDataSQL: function() {
            var self = this;
            var data = $.get('/dashboard-SalePurchaseExpense');
            return data;
        },
        /*
        =====================================================
            DATA BY DAY
        =====================================================
        */
        getContent:function(day) {
            var self = this;
            var week = moment().week();
            return _.flatten(_.filter(self.content,function (inv) {
                return moment(inv.date).week() === week & moment(inv.date).weekday() === day;
            }));
        },
        /*
        =====================================================
            GET PERCENTAGE
        =====================================================
        */
        getPercentage: function(amount, objetive){
            var self = this;
            var percentage = 0;
            if(objetive > 0){
                percentage = (amount * 100)/objetive;
            }
            return percentage;
        },
        /*
        =====================================================
            SHOW TODAY
        =====================================================
        */
        fetchToday: function (type) {
            var self = this;
            var amount = 0;
            /*
            =========================================================================================
                VENTAS
            =========================================================================================
            */
            if(type == "sale"){
                // console.log("ESTOY");
                var today = moment().format('YYYY-MM-DD');
                var PosOrder = _.reduce(_.map(self.PosOrder,function(item) {
                    var utc = moment.utc(item.date,'YYYY-MM-DD h:mm:ss A');
                    utc = moment(utc._d).format('YYYY-MM-DD');
                    if(utc == today){
                        return item.amount;
                    }else{
                        return 0;
                    }
                }),function(memo, num) {
                    return memo + num;
                },0);
                var AccountInvoice = _.reduce(_.map(self.AccountInvoice,function(item) {
                    if(item.date ==  moment().format('YYYY-MM-DD') && item.type == "out_invoice"){
                        var origin = 0;

                        if(item.origin == '%SO%'){
                            origin = item.amount;
                        }
                        return origin;
                    }else{
                        return 0;
                    }

                    // if(item.date ==  moment().format('YYYY-MM-DD') && item.type == "out_invoice" && item.origin <> '%INTEREST%'){
                    //     return item.amount;
                    // }else{
                    //     return 0;
                    // }
                }),function(memo, num) {
                    return memo + num;
                },0);
                var AccountInvoiceRefund = _.reduce(_.map(self.AccountInvoice,function(item) {
                    if(item.date ==  moment().format('YYYY-MM-DD') && item.type == "out_refund" && item.origin != '%INTEREST%'){
                        return item.amount;
                    }else{
                        return 0;
                    }
                }),function(memo, num) {
                    return memo + num;
                },0);
                amount = PosOrder + AccountInvoice - AccountInvoiceRefund;
            }
            /*
            =========================================================================================
                COMPRAS
            =========================================================================================
            */
            if(type == "purchase"){
                var purchase = _.reduce(_.map(self.AccountInvoice,function(item) {
                    if(item.type == 'in_invoice' && item.origin != null && item.date ==  moment().format('YYYY-MM-DD')){
                        var origin = 0;
                        if(item.origin.match(/PO/) != null){
                            origin = item.amount;
                        }
                        return origin;
                    }else{
                        return 0;
                    }
                }),function(memo, num) {
                    return memo + num;
                },0);
                amount = purchase;
            }
            /*
            =========================================================================================
                GASTOS
            =========================================================================================
            */
            if(type == "expense"){
                var expense = _.reduce(_.map(self.AccountInvoice,function(item) {
                    if(item.type == 'in_invoice' && item.date ==  moment().format('YYYY-MM-DD')){
                        if(item.origin == null){
                            return item.amount;
                        }else{
                            var origin = 0;
                            if(item.origin != null){
                                if(item.origin.match(/PO/) == null){
                                    origin = item.amount;
                                }
                            }
                            return origin;
                        }
                    }else{
                        return 0;
                    }
                }),function(memo, num) {
                    return memo + num;
                },0);

                // RRHH

                var net = _.reduce(_.map(self.HrPayslip,function(item) {
                    if(moment(item.date).format('YYYY-MM-DD') ==  moment().format('YYYY-MM-DD')){
                        return item.net;
                    }else{
                        return 0;
                    }
                }),function(memo, num) {
                    return memo + num;
                },0);

                var ipsc = _.reduce(_.map(self.HrPayslip,function(item) {
                    if(item.code == 'IPSC' && item.ipsc != null && moment(item.date).format('YYYY-MM-DD') == moment().format('YYYY-MM-DD')){
                        return item.ipsc;
                    }else{
                        return 0;
                    }
                }),function(memo, num) {
                    return memo + num;
                },0);

                var ipse = _.reduce(_.map(self.HrPayslip,function(item) {
                    if(item.code == 'IPSE' && item.ipse != null && moment(item.date).format('YYYY-MM-DD') == moment().format('YYYY-MM-DD')){
                        return item.ipse * -1;
                    }else{
                        return 0;
                    }
                }),function(memo, num) {
                    return memo + num;
                },0);

                amount = expense + net + ipse + ipsc;
            }

            if(type == "payment"){
                var payment = _.reduce(_.map(self.AccountVoucher,function(item) {
                    if(item.type == 'receipt' && item.date ==  moment().format('YYYY-MM-DD')){
                        return item.amount;
                    }else{
                        return 0;
                    }
                }),function(memo, num) {
                    return memo + num;
                },0);
                amount = payment;
            }
            self.today = amount;
        },
        /*
        =====================================================
            SHOW WEEK
        =====================================================
        */
        fetchWeek: function (type) {
            var self = this;
            var amount = 0;
            var content = [];
            /*
            =========================================================================================
                VENTAS
            =========================================================================================
            */
            if(type == "sale"){
                var utc = self.fetchUTC();
                var week_from = moment().weekday(0).format('YYYY-MM-DD 00:00:00');
                week_from = moment(week_from).add(utc,'hours').format('YYYY-MM-DD HH:mm:ss');
                var week_to = moment(week_from).weekday(7).format('YYYY-MM-DD HH:mm:ss');
                var PosOrder = _.reduce(_.map(self.PosOrder,function(item) {
                    if(item.date >= week_from && item.date < week_to){
                        var utc = moment.utc(item.date,'YYYY-MM-DD h:mm:ss A');
                        content.push({
                            date: moment(utc._d).format('YYYY-MM-DD'),
                            amount: item.amount,
                        });
                        return item.amount;
                    }else{
                        return 0;
                    }
                }),function(memo, num) {
                    return memo + num;
                },0);
                var AccountInvoice = _.reduce(_.map(self.AccountInvoice,function(item) {
                    if(item.date >= moment().weekday(0).format('YYYY-MM-DD') && item.date < moment().weekday(7).format('YYYY-MM-DD') && item.type == "out_invoice" && item.origin == '%SO%'){
                        content.push({
                            date: item.date,
                            amount: item.amount,
                        });
                        return item.amount;
                    }else{
                        return 0;
                    }
                }),function(memo, num) {
                    return memo + num;
                },0);
                var AccountInvoiceRefund = _.reduce(_.map(self.AccountInvoiceRefund,function(item) {
                    if(item.date >= moment().weekday(0).format('YYYY-MM-DD') && item.date < moment().weekday(7).format('YYYY-MM-DD') && item.type == "out_refund"){
                        content.push({
                            date: item.date,
                            amount: item.amount * -1,
                        });
                        return item.amount;
                    }else{
                        return 0;
                    }
                }),function(memo, num) {
                    return memo + num;
                },0);
                amount = PosOrder + AccountInvoice - AccountInvoiceRefund;
            }
            /*
            =========================================================================================
                COMPRAS
            =========================================================================================
            */
            if(type == "purchase"){
                var purchase = _.reduce(_.map(self.AccountInvoice,function(item) {
                    /*
                    ============================
                        CONTENIDO DE LA SEMANA
                    ============================
                    */
                    if(item.type == 'in_invoice' && item.origin != null && item.date >= moment().weekday(0).format('YYYY-MM-DD') && item.date < moment().weekday(7).format('YYYY-MM-DD')){
                        var origin = 0;
                        if(item.origin.match(/PO/) != null){
                            content.push({
                                date: item.date,
                                amount: item.amount,
                            });
                            origin = item.amount;
                        }
                        return origin;
                    }else{
                        return 0;
                    }
                }),function(memo, num) {
                    return memo + num;
                },0);
                amount = purchase;
            }
            /*
            =========================================================================================
                GASTOS
            =========================================================================================
            */
            if(type == "expense"){
                var expense = _.reduce(_.map(self.AccountInvoice,function(item) {
                    /*
                    ============================
                        CONTENIDO DE LA SEMANA
                    ============================
                    */
                    if(item.type == 'in_invoice' && item.date >= moment().weekday(0).format('YYYY-MM-DD') && item.date < moment().weekday(7).format('YYYY-MM-DD')){
                        if(item.origin == null){
                            content.push({
                                date: item.date,
                                amount: item.amount,
                            });
                            return item.amount;
                        }else{
                            var origin = 0;
                            if(item.origin != null){
                                if(item.origin.match(/PO/) == null){
                                    content.push({
                                        date: item.date,
                                        amount: item.amount,
                                    });
                                    origin = item.amount;
                                }
                            }
                            return origin;
                        }
                    }else{
                        return 0;
                    }
                }),function(memo, num) {
                    return memo + num;
                },0);

                var net = _.reduce(_.map(self.HrPayslip,function(item) {
                    if(item.date >= moment().weekday(0).format('YYYY-MM-DD') && item.date < moment().weekday(7).format('YYYY-MM-DD')){
                        content.push({
                            date: item.date,
                            amount: item.net,
                        });
                        return item.net;
                    }else{
                        return 0;
                    }
                }),function(memo, num) {
                    return memo + num;
                },0);

                var ipsc = _.reduce(_.map(self.HrPayslip,function(item) {
                    if(item.code == 'IPSC' && item.ipsc != null && item.date >= moment().weekday(0).format('YYYY-MM-DD') && item.date < moment().weekday(7).format('YYYY-MM-DD')){
                        content.push({
                            date: item.date,
                            amount: item.ipsc,
                        });
                        return item.ipsc;
                    }else{
                        return 0;
                    }
                }),function(memo, num) {
                    return memo + num;
                },0);

                var ipse = _.reduce(_.map(self.HrPayslip,function(item) {
                    if(item.code == 'IPSE' && item.ipse != null && item.date >= moment().weekday(0).format('YYYY-MM-DD') && item.date < moment().weekday(7).format('YYYY-MM-DD')){
                        content.push({
                            date: item.date,
                            amount: item.ipse * -1,
                        });
                        return item.ipse * -1;
                    }else{
                        return 0;
                    }
                }),function(memo, num) {
                    return memo + num;
                },0);
                amount = expense + net + ipse + ipsc;
            }

            if(type == "payment"){
                var payment = _.reduce(_.map(self.AccountVoucher,function(item) {
                    /*
                    ============================
                        CONTENIDO DE LA SEMANA
                    ============================
                    */
                    if(item.type == 'receipt' && item.date >= moment().weekday(0).format('YYYY-MM-DD') && item.date < moment().weekday(7).format('YYYY-MM-DD')){
                      content.push({
                          date: item.date,
                          amount: item.amount,
                      });
                        return item.amount;
                    }else{
                        return 0;
                    }

                }),function(memo, num) {
                    return memo + num;
                },0);
                amount = payment;
            }
            self.week = amount;
            self.content = content;
        },
        /*
        =====================================================
            SHOW MONTH
        =====================================================
        */
        fetchMonth: function () {
            var self = this;
            var content = [];
            var CurrencyBase = self.ResCompany[0].currency_id;
            /*
            =======================
                VENTAS
            =======================
            */
            var PosOrder = _.reduce(_.map(self.PosOrder,function(item) {
                var utc = moment.utc(item.date,'YYYY-MM-DD h:mm:ss A');
                utc = moment(utc._d).format('YYYY-MM-DD');
                var value = 0;
                if(moment(utc).format('YYYY-MM') == moment().format('YYYY-MM')){
                    value = item.amount;
                }
                return value;
            }),function(memo, num) {
                return memo + num;
            },0);
            // && item.origin == '%SO%'
            var AccountInvoice = _.reduce(_.map(self.AccountInvoice,function(item) {
            //     if(item.type == 'out_invoice' && item.origin == '%SO%'){
            //         return item.amount;
            //     }else{
            //         return 0;
            //     }
            // }),function(memo, num) {
            //     return memo + num;
            // },0);
            if(item.type == 'out_invoice'){
                var origin = 0;
                if(item.origin.match(/SO/) != null){
                    origin = item.amount;
                }
                return origin;
              }else{
                  return 0;
              }
            }),function(memo, num) {
                return memo + num;
            },0);
            var AccountInvoiceRefund = _.reduce(_.map(self.AccountInvoice,function(item) {
                if(item.type == 'out_refund'){
                    return item.amount;
                }else{
                    return 0;
                }
            }),function(memo, num) {
                return memo + num;
            },0);
            var sale = PosOrder + AccountInvoice - AccountInvoiceRefund;
            /*
            =======================
                COMPRAS
            =======================
            */
            var purchase = _.reduce(_.map(self.AccountInvoice,function(item) {
                if(item.type == 'in_invoice' && item.origin != null){
                    var origin = 0;
                    if(item.origin.match(/PO/) != null){
                        origin = item.amount;
                    }
                    return origin;
                }else{
                    return 0;
                }
            }),function(memo, num) {
                return memo + num;
            },0);
            /*
            =======================
                GASTOS
            =======================
            */
            var expense = _.reduce(_.map(self.AccountInvoice,function(item) {
                if(item.type == 'in_invoice'){
                    if(item.origin == null){
                        return item.amount;
                    }else{
                        var origin = 0;
                        if(item.origin != null){
                            if(item.origin.match(/PO/) == null){
                                origin = item.amount;
                            }
                        }
                        return origin;
                    }
                }else{
                    return 0;
                }
            }),function(memo, num) {
                return memo + num;
            },0);

            /*
            =======================
                COBROS
            =======================
            */

            var payment = _.reduce(_.map(self.AccountVoucher,function(item) {
              if(item.type == 'receipt'){
                  return item.amount;
              }else{
                  return 0;
              }
            }),function(memo, num) {
                return memo + num;
            },0);

            /*
            =======================
                RECURSOS HUMANOS
            =======================
            */

            var net = _.reduce(_.map(self.HrPayslip,function(item) {
                return item.net;
            }),function(memo, num) {
                return memo + num;
            },0);

            var ipsc = _.reduce(_.map(self.HrPayslip,function(item) {
                if(item.code == 'IPSC' && item.ipsc != null){
                    return item.ipsc;
                }else{
                    return 0;
                }
            }),function(memo, num) {
                return memo + num;
            },0);

            var ipse = _.reduce(_.map(self.HrPayslip,function(item) {
                if(item.code == 'IPSE' && item.ipse != null){
                    return item.ipse * -1;
                }else{
                    return 0;
                }
            }),function(memo, num) {
                return memo + num;
            },0);

            expense = expense + net + ipse + ipsc;

            self.$el.find('.widget-content').find('#number_sale').text(accounting.formatMoney(sale, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator));
            self.$el.find('.widget-content').find('#number_purchase').text(accounting.formatMoney(purchase, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator));
            self.$el.find('.widget-content').find('#number_expense').text(accounting.formatMoney(expense, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator));
            self.$el.find('.widget-content').find('#number_payment').text(accounting.formatMoney(payment, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator));

            self.SaleMonth = sale;
            self.PurchaseMonth = purchase;
            self.ExpenseMonth = expense;
            self.PaymentMonth = payment;
            self.BuildWidget(sale,purchase,expense,payment);
        },

        BuildWidget: function(sale,purchase,expense,payment){
            var self = this;
            var SaleObjetive = 0;
            var PurchaseLimit = 0;
            var ExpenseLimit = 0;
            var PaymentObjetive = 0;

            if(self.DashboardObjetive.length > 0){
                self.SaleObjetiveAmount = self.DashboardObjetive[0].sale_objetive;
                self.PurchaseLimitAmount = self.DashboardObjetive[0].purchase_limit;
                self.ExpenseLimitAmount = self.DashboardObjetive[0].expense_limit;
                self.PaymentObjetiveAmount = self.DashboardObjetive[0].payment_objetive;

                SaleObjetive = self.getPercentage(sale, self.SaleObjetiveAmount);
                PurchaseLimit = self.getPercentage(purchase, self.PurchaseLimitAmount);
                ExpenseLimit = self.getPercentage(expense, self.ExpenseLimitAmount);
                PaymentObjetive = self.getPercentage(payment, self.PaymentObjetiveAmount)
            }

            $("#circle-sale").circliful({
                animationStep: 10,
                foregroundBorderWidth: 12,
                backgroundBorderWidth: 1,
                percent: SaleObjetive,
                fontColor: '#43a047',
                foregroundColor: '#43a047',
                percentageTextSize: 35,
            });

            $("#circle-purchase").circliful({
                animationStep: 10,
                foregroundBorderWidth: 12,
                backgroundBorderWidth: 1,
                percent: PurchaseLimit,
                fontColor: '#f9a825',
                foregroundColor: '#f9a825',
                percentageTextSize: 35,
            });

            $("#circle-expense").circliful({
                animationStep: 10,
                foregroundBorderWidth: 12,
                backgroundBorderWidth: 1,
                percent: ExpenseLimit,
                fontColor: '#ef6c00',
                foregroundColor: '#ef6c00',
                percentageTextSize: 35,
            });

            $("#circle-payment").circliful({
                animationStep: 10,
                foregroundBorderWidth: 12,
                backgroundBorderWidth: 1,
                percent: PaymentObjetive,
                fontColor: '#0288d1',
                foregroundColor: '#0288d1',
                percentageTextSize: 35,
            });

            self.SalePercentage = SaleObjetive;
            self.PurchasePercentage = PurchaseLimit;
            self.ExpensePercentage = ExpenseLimit;
            self.PaymentPercentage = PaymentObjetive;
        },

        BuildChartWeek: function(ChartColor){
            var self = this;
            var data = [];
            var CurrencyBase = self.ResCompany[0].currency_id;
            var label = ['Domingo','Lunes', 'Martes', 'Miercoles','Jueves','Viernes','Sabado'];
            var body = [];
            var name = '.week-dashboard-chart';
            for (var i = 0; i < 7; i++) {
                var content = self.getContent(i);
                var amount = _.reduce(_.map(content,function(item) {
                    return item.amount;
                }),function(memo, num) {
                    return memo + num;
                },0);
                body.push(amount);
            }
            var chart = new widget.DashboardChartWidget(self);
            chart.BuildLineChart(name,label,body,CurrencyBase,ChartColor,ChartColor);
        },
        RedirectSale: function() {
            var self = this;
            self.do_action({
                type: 'ir.actions.client',
                tag: "eiru_reports.sale_action",
                target: 'current',
                params: {},
                context: self.session.user_context,
            });
            self.removeModal();
        },
        RedirectPurchase: function() {
            var self = this;
            self.do_action({
                type: 'ir.actions.client',
                tag: "eiru_reports.purchase_action",
                target: 'current',
                params: {},
                context: self.session.user_context,
            });
            self.removeModal();
        },
        RedirectExpense: function() {
            var self = this;
            self.do_action({
                type: 'ir.actions.client',
                tag: "eiru_reports.expense_action",
                target: 'current',
                params: {},
                context: self.session.user_context,
            });
            self.removeModal();
        },

        RedirectPayment: function() {
            var self = this;
            self.do_action({
                type: 'ir.actions.client',
                tag: "eiru_reports.customer_payment_action",
                target: 'current',
                params: {},
                context: self.session.user_context,
            });
            self.removeModal();
        },
        /*
        =====================================================
            MODAL
        =====================================================
        */
        showModal: function (e){
            var self = this;
            var titleData = [];
            var ObjectiveTitle;
            var ObjectivePendingTitle;
            var ObjectivePending;
            var Objective;
            var Today;
            var Week;
            var Month;
            var ObjectivePercentage;
            var ChartColor;
            var CurrencyBase = self.ResCompany[0].currency_id;
            var type = $(e.target).closest('a')[0].className;
            if(type == 'number_sale'){
                self.fetchToday('sale');
                self.fetchWeek('sale');
                ChartColor = '#43a047';
                ObjectivePercentage = self.SalePercentage;
                titleData.push({
                    title: 'Ventas',
                });
                ObjectiveTitle = "Meta del mes";
                ObjectivePendingTitle = "Faltante para logar la meta del mes";
                ObjectivePending = accounting.formatMoney(self.SaleObjetiveAmount - self.SaleMonth, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
                Objective = accounting.formatMoney(self.SaleObjetiveAmount, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
                Today = accounting.formatMoney(self.today, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
                Week = accounting.formatMoney(self.week, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
                Month = accounting.formatMoney(self.SaleMonth, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
            }
            if(type == 'number_purchase'){
                self.fetchToday('purchase');
                self.fetchWeek('purchase');
                ChartColor = '#f9a825';
                ObjectivePercentage = self.PurchasePercentage;
                titleData.push({
                    title: 'Compras',
                });
                ObjectiveTitle = "Limite de compras del mes";
                ObjectivePendingTitle = "Sobrante del presupuesto del mes";
                ObjectivePending = accounting.formatMoney(self.PurchaseLimitAmount - self.PurchaseMonth, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
                Objective = accounting.formatMoney(self.PurchaseLimitAmount, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
                Today = accounting.formatMoney(self.today, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
                Week = accounting.formatMoney(self.week, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
                Month = accounting.formatMoney(self.PurchaseMonth, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
            }
            if(type == 'number_expense'){
                self.fetchToday('expense');
                self.fetchWeek('expense');
                ChartColor = '#ef6c00';
                ObjectivePercentage = self.ExpensePercentage;
                titleData.push({
                    title: 'Gastos',
                });
                ObjectiveTitle = "Limite de gastos del mes";
                ObjectivePendingTitle = "Sobrante del presupuesto del mes";
                ObjectivePending = accounting.formatMoney(self.ExpenseLimitAmount - self.ExpenseMonth, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
                Objective = accounting.formatMoney(self.ExpenseLimitAmount, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
                Today = accounting.formatMoney(self.today, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
                Week = accounting.formatMoney(self.week, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
                Month = accounting.formatMoney(self.ExpenseMonth, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
            }
            if(type == 'number_payment'){
                self.fetchToday('payment');
                self.fetchWeek('payment');
                ChartColor = '#0288d1';
                ObjectivePercentage = self.PaymentPercentage;
                titleData.push({
                    title: 'Cobros',
                });
                ObjectiveTitle = "Objetivo de cobros del mes";
                ObjectivePendingTitle = "Faltante del mes";
                ObjectivePending = accounting.formatMoney(self.PaymentObjetiveAmount - self.PaymentMonth, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
                Objective = accounting.formatMoney(self.PaymentObjetiveAmount, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
                Today = accounting.formatMoney(self.today, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
                Week = accounting.formatMoney(self.week, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
                Month = accounting.formatMoney(self.PaymentMonth, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
            }
            var modal = Qweb.render('WidgetModal', {
                modalTitle: titleData,
                objectiveTitle: ObjectiveTitle,
                objectivePending: ObjectivePendingTitle,
                pending: ObjectivePending,
                objective: Objective,
                today: Today,
                week: Week,
                month: Month,
            });
            $('.openerp_webclient_container').after(modal);
            $('.widget-modal').modal();
            $('.widget-modal').on('hidden.bs.modal', function (e) {
                self.removeModal(e);
            });
            var contenido = $('.widget-modal').find('.redirect-to-report');
            contenido.click(function (e) {
                if(type == 'number_sale'){
                    self.RedirectSale();
                }
                if(type == 'number_purchase'){
                  self.RedirectPurchase();
                }
                if(type = 'number_payment'){
                  self.RedirectPayment();
                }else{
                  self.RedirectExpense();
                }

            });
            $("#myItemModal").circliful({
                animationStep: 10,
                foregroundBorderWidth: 12,
                backgroundBorderWidth: 1,
                percent: ObjectivePercentage,
                fontColor: ChartColor,
                foregroundColor: ChartColor,
                percentageTextSize: 35,
            });
            self.BuildChartWeek(ChartColor);
        },
        removeModal: function (e) {
            $('.widget-modal').remove();
            $('.modal-backdrop').remove();
        },
    });
}
