function widget_stock_valuation(widget) {
    "use strict";

    var model = openerp;

    widget.WidgetStockValuation = widget.Base.extend({
        template: 'WidgetStockValuation',
        content: [],

        events: {
            'click .valuation': 'Redirect',
            'click .quantity': 'Redirect',
        },

        init: function (parent) {
            this._super(parent, {
                width: 6,
                height: 3
            });
        },

        start: function () {
            var self = this;
            self.fetchInitial();
        },

        fetchInitial: function(){
            var self = this;
            self.fetchStockValuationSQL().then(function (StockValuationSQL) {
                return StockValuationSQL;
            }).then(function(StockValuationSQL) {
                self.Valuation = StockValuationSQL.valuation;
                self.ResCompany = StockValuationSQL.company;
                return self.ShowValuation();
            });
        },

        fetchStockValuationSQL: function() {
            var self = this;
            var data = $.get('/dashboard-StockValuation');
            return data;
        },

        ShowValuation: function () {
            var self = this;

            var CurrencyBase = self.ResCompany[0].currency_id;
            self.$el.find('.widget-content').find('#valuation').text(accounting.formatMoney(self.Valuation[0].valuation, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator));
            self.$el.find('.widget-content').find('#quantity').text(accounting.formatNumber(self.Valuation[0].quantity,2,'.',','));
        },

        Redirect: function() {
            var self = this;
            self.do_action({
                type: 'ir.actions.client',
                tag: "eiru_reports.stock_valuation_action",
                target: 'current',
                params: {},
                context: self.session.user_context,
            });
        },
    });
}
