function widget_stock_valuation_with_variant_cost_price(widget) {
    "use strict";

    var model = openerp;

    widget.WidgetStockValuationVariantCostPrice = widget.Base.extend({
        template: 'WidgetStockValuationVariantCostPrice',
        content: [],

        events: {
            'click .valuation': 'Redirect',
            'click .quantity': 'Redirect',
        },

        init: function (parent) {
            this._super(parent, {
                width: 6,
                height: 3
            });
        },

        start: function () {
            var self = this;
            self.fetchInitial();
        },

        fetchInitial: function(){
            var self = this;
            self.fetchStockValuationSQL().then(function (StockValuationSQL) {
                return StockValuationSQL;
            }).then(function(StockValuationSQL) {
                self.Valuation = StockValuationSQL.valuation;
                self.ResCompany = StockValuationSQL.company;
                return self.ShowValuation();
            });
        },

        fetchStockValuationSQL: function() {
            var self = this;
            var data = $.get('/dashboard-StockValuationWithVariantCostPrice');
            return data;
        },

        ShowValuation: function () {
            var self = this;

            var CurrencyBase = self.ResCompany[0].currency_id;
            var contador = 0;
            var value = _.reduce(_.map(self.Valuation, function (map) {
                if(map.variant_cost == null){
                    return map.template_cost;
                }else{
                    return map.variant_cost;
                }
            }), function (meno,num) {
                return meno + num;
            }, 0);
            var quantity = _.reduce(_.map(self.Valuation, function (map) {
                return map.qty;
            }), function (meno,num) {
                return meno + num;
            }, 0);
            self.$el.find('.widget-content').find('#valuation').text(accounting.formatMoney(value, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator));
            self.$el.find('.widget-content').find('#quantity').text(accounting.formatNumber(quantity,2,'.',','));
        },

        Redirect: function() {
            var self = this;
            self.do_action({
                type: 'ir.actions.client',
                tag: "eiru_reports.stock_valuation_action",
                target: 'current',
                params: {},
                context: self.session.user_context,
            });
        },
    });
}
